2011-05-05  Veerapuram Varadhan  <v.varadhan@gmail.com>

	** Fixes 688773
	* RecordCache.cs (CopyRecord): When copying records, assign default value 
	for the columns that does not exist in the row being imported.

2010-07-23  Veerapuram Varadhan  <v.varadhan@gmail.com>

	** Fixes #565616 - Based on Patch by Hubert FONGARNAND
	* DataContainer.cs (GetContainerData): If typecode is string, 
	call Convert.ToString() irrespective of whether value is 
	IConvertible or not. 
	
2010-03-26  Veerapuram Varadhan  <vvaradhan@novell.com>

    ** Fixes #564833/580736
    * DbDataAdapter.cs (*Command): Fix for .NET compatibility which
    supports both type of adapters with/without discrete command
    instances.
        	
2009-10-28  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes #385028/#385029
	* DbCommandBuilder.cs (CreateInsertCommand): Workaround for inserting 
	DEFAULT values to non-null-columns.
	(GetInsertCommand): New overload added to handle above workaround.
	(set_DataAdapter): Register for the RowUpdatingEventHandlers.
	 
2009-10-14  Jonathan Pryor  <jpryor@novell.com>

	* DbConnection.cs: Throw NotImplementedException fom
	  DbConnection.DbProviderFactory, as DbProviderFactories isn't
	  included in the MonoTouch profile.

2009-07-30  Veerapuram Varadhan  <vvaradhan@novell.com>

	* DbDataAdapter.cs (IDbDataAdapter.get_*Command): For non 2.0 profile, do not 
	implement these properties and related changes.
	
2009-07-30  Veerapuram Varadhan  <vvaradhan@novell.com>
	
	* DbDataAdapter.cs (set_DeleteCommand): Code cleanup.
	
2009-07-29  Veerapuram Varadhan  <vvaradhan@novell.com>
	
	* DbDataAdapter.cs (*Command properties): Don't call IDbDataAdapter.*Command, 
	as provider specific DbDataAdapters would have its own implementation.
	
2009-07-27  Veerapuram Varadhan  <vvaradhan@novell.com>

	* DbCommandBuilder.cs (CreateUpdateCommand): Don't set Nullable 
	property "Original_*" fields.
	
2009-07-24  Veerapuram Varadhan  <vvaradhan@novell.com>
	
	* DbCommandBuilder.cs (Create*Command): Fill up the missing pieces from 
	SqlCommandBuilder version of Create*Commands that fixes the failing tests.
	
2009-07-24  Veerapuram Varadhan  <vvaradhan@novell.com>
	
	* DbCommandBuilder.cs (CreateDeleteCommand, CreateUpdateCommand): Add the 
	nullcheck-param into the respective command's parameter list.  Fixes 
	build breaks.  Individual provider's CommandBuilder classes from 2.0 
	profile onwards use the base version of methods to maintain these commands.
	(Get*Command): Cleanup code duplication
	* DbDataAdapter (Update): Use SourceColumnNullMapping property to handle 
	nullcheckparams.  Fixes #522624.  Patch by 
	Gert Driesen  <drieseng@users.sourceforge.net>.
	
2009-07-15  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Part of fix for #325464
	* DbParameter.cs (FrameworkDbType, DbTypeMapping, SystemType): New internal properties 
	required to convert between DbType/FrameworkType/SystemType.
	
2009-05-10  Marek Habersack  <mhabersack@novell.com>

	* DbConnection.cs: implemented the DbProviderFactory property

2009-03-31  Veerapuram Varadhan  <vvaradhan@novell.com>

	* Fixes rest of #480377
	* DataContainer.cs (GetContainerData, GetExplicitValue): Added to handle cases 
	where passed type overloads an explicit operator for conversion of values.
	
2009-01-03  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbCommandBuilder.cs (QuoteIdentifier): Throw NotSupportedException.
	* DbDataAdapter.cs (Update): Add row causing concurrency violation
	to DBConcurrencyException.

2008-12-30  Raja R Harinath  <harinath@hurrynot.org>

	Mildly rewrite duplicate-inferring logic.
	* Index.cs (IndexDuplicateState): Remove.
	(_hasDuplicates): Remove.  Replace by ...
	(know_have_duplicates, know_no_duplicates): ... these.

2008-12-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbCommandBuilder.cs: When CatalogSeparator or SchemaSeparator are
	not set (or explicitly set to null or empty string), then return
	default separator character. Added value check for CatalogLocation and
	ConflictOption. Removed regions.

2008-12-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbCommandBuilder.cs: Fixed default value for ConflicOption.

2008-12-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbCommandBuilder.cs: Return a zero-length string when QuotePrefix or
	QuoteSuffix are not set (or are set to null). Changing QuotePrefix or
	QuoteSuffix after a command has been generated should result in an
	InvalidOperationException.
	* DbConnectionStringBuilder.cs: Added support for ODBC rules. Major
	rewrite fixing many compatibility issues, and improving support for
	connectionstring formats/characters.

2008-11-25  Atsushi Enomoto  <atsushi@ximian.com>

	* DbDataRecord.cs : it is abstract, so create different impl. class.
	* DbEnumerator.cs : use above.

2008-11-17  Raja R Harinath  <harinath@hurrynot.org>

	Avoid allocating empty arrays.
	* Index.cs (empty): New empty array constant.
	(Reset): Initialize '_array' to 'empty'.
	(RebuildIndex): Don't allocate array if it will be empty.
	(FindAllIndexes): Use 'empty' instead of 'new int [0]'.

2008-11-17  Raja R Harinath  <harinath@hurrynot.org>

	* Index.cs: Remove use of Array and Size properties by taking
	advantage of the invariant that _array is never null.
	(EnsureArray): Remove.
	(Array): Remove.

2008-11-17  Raja R Harinath  <harinath@hurrynot.org>

	* RecordCache.cs: Reduce some extraneous nesting.

2008-10-07  Daniel Morgan  <monodanmorg@yahoo.com>

	* DbConnectionStringBuilder.cs: fix setting and getting
	the ConnectionString property

2008-09-16  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes#421336 - Patch provided by <christian_hoff@gmx.net> 	
	DbCommandBuilder.cs: Several scenarios leading to exceptions when
	creating the update, insert and delete commands: 

	1. The "IsExpression" column in the column schema table can also
	be DBNull which is equivalent to "false" but the DBCommandBuilder
	does not check for DBNull and simply tries to cast it into a bool,
	which will fail.

	2. The commands do not get refreshed after a call to
	UpdateSchema() because they are not set to NULL. This has the
	consequence that empty commands(created with CreateNewCommand())
	are returned afterwards.

	3. Multiple parameters with the same name are generated if the
	parameter names should be named after the columns.
	
2008-09-05  Raja R Harinath  <harinath@hurrynot.org>

	* DataContainer.cs (*.ZeroOut): Rename from the somewhat unclear
	'SetDefaultValue'.
	(IsNull): Use a more idiomatic form of the short-circuit.
	(*.SetValue): Convert to one-liners.

2008-08-08  Raja R Harinath  <harinath@hurrynot.org>

	Reduce massive code duplication
	* DataContainer.cs (DataContainer): Rename from	AbstractDataContainer.
	Introduce new 'protected abstract' members to encapsulate
	type-specific handling, and move all common code here.
	(DataContainer.Create): Rename from CreateInstance.

2008-07-06  Sebastien Pouliot  <sebastien@ximian.com> 

	* DbDataReader.cs: Replace a few Type.GetType by typeof
	[Found using Gendarme AvoidTypeGetTypeForConstantStringsRule]

2008-07-03  Marek Habersack  <mhabersack@novell.com>

	* DataAdapter.cs (BuildSchema): Check for null.
	
2008-07-01  Rodrigo Kumpera  <rkumpera@novell.com>

	* RecordCache.cs: Kill some foreach loops.

2008-04-21  Gert Driesen  <drieseng@users.sourceforge.net>

	* DataColumnMappingCollection.cs: Modified argument names to match
	MS. Code formatting.
	* DataTableMappingCollection.cs: Modified argument names to match MS.
	Code formatting.

2008-03-23  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbDataAdapter.cs: Corcompare fixes and code formatting.
	* DbDataRecord.cs: Corcompare fixes and code formatting.
	* DataColumnMappingCollection.cs: Corcompare fixes and code formatting.
	* RowUpdatedEventArgs.cs: Corcompare fixes and code formatting.
	* DbParameterCollection.cs: Corcompare fixes and code formatting.

2007-11-15  Atsushi Enomoto  <atsushi@ximian.com>

	* DbProviderFactoriesConfigurationHandler.cs : Create() now takes
	  parent DataSet into consideration i.e. it now merges items in
	  different configurations. Fixed bug #323708.

2007-10-21  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbDataPermissionAttribute.cs: In KeyRestrictionBehavior, reuse
	ExceptionHelper.CheckEnumValue.
	* ExceptionHelper.cs: Use same exception message for both 1.0 and 2.0.
	* Index.cs: Fixed compiler warnings. Code formatting.

2007-10-20  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbDataAdapter.cs: Implemented UpdateBatchSize setter.
	* DataAdapter.cs: In FillLoadOption setter, ensure value is valid.
	Modified MissingMappingAction and MissingSchemaAction setters to use
	ExceptionHelper.CheckEnumValue to validate value. Spaces to tabs and
	code formatting.
	* ExceptionHelper.cs: Added CheckEnumValue method and modified
	InvalidEnumValueException method to return AORE on 2.0 profile. Added
	ConnectionClosed method that returns an InvalidOperationException.

2007-10-19  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbTransaction.cs: Do not perform a rollback in Dispose (bool).
	Leaves it up to deriving classes to override Dispose (bool) and
	perform a rollback if necessary. Fixes bug #325397. Code formatting.
	* ExceptionHelper.cs: Added TransactionNotUsable method that constructs
	an InvalidOperationException to be thrown by IDbTransaction
	implementations when the transaction is no longer open.

2007-09-27  Nagappan A <anagappan@novell.com> 

	* DbDataAdapter.cs: Added MonoTODO in appropriate place.
	
	* DbCommandBuilder.cs (initializeCommand): Implemented missing API.

2007-09-25  Nagappan A  <anagappan@novell.com>

	* DbConnection.cs: 2.0 attribute fixes.

	* DataColumnMapping.cs: 2.0 attribute fixes.

	* DbParameterCollection.cs: Code alignment.

	* DataAdapter.cs: 2.0 attribute fixes.

	* DataTableMapping.cs: 2.0 attribute fixes.

	* RowUpdatingEventArgs.cs (BaseCommand): Code alignment.

2007-09-24  Konstantin Triger <kostat@mainsoft.com>

	* DbEnumerator.cs, DbDataRecord.cs: refactoring.
	* DbDataRecord.cs: GetValue() should return null instead of DBNull.

2007-08-10  Nagappan A  <anagappan@novell.com>

	* DbDataAdapter.cs (Fill): Fixed method signature.

2007-07-26  Nagappan A  <anagappan@novell.com>

	* DbConnection.cs: Removed bogus TODO.

2007-07-22  Nagappan A  <anagappan@novell.com>

	* DbConnection.cs: 2.0 missing features.

	* DbDataAdapter.cs: 2.0 missing features.

2007-06-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbDataAdapter.cs: Marked ICloneable.Clone obsolete to match MS.

2007-06-21  Nagappan A  <anagappan@novell.com>

	* DbConnectionStringBuilder.cs (Init): Modified the dictionary to
	use StringComparer.InvariantCultureIgnoreCase.
	(Add, ContainsKey): Checks whether argument is null or empty string.

2007-05-08  Adar Wesley <adarw@mainsoft.com>

	* DbProviderFactory.cs: minor refactoring for throwing exceptions

2007-04-30  Marek Habersack  <mhabersack@novell.com>

	* DbProviderFactories.cs: throw the same exception MS.NET does.

2007-03-03  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbProviderFactoriesConfigurationHandler.cs: Added support for
	clear node.

2007-03-03  Gert driesen  <drieseng@users.sourceforge.net>

	* ConnectionStringsSectionHandler.cs: Removed since the 2.0 config
	API is in place.
	* DbProviderFactoriesConfigurationHandler.cs: Fixed name of DataSet
	to match MS. Removed SupportedClasses column since this is no longer
	part of 2.0 profile (removed during beta). Throw 
	ConfigurationErrorsException for unrecognized elements. Mark methods
	private, and refactor them. Added FIXMEs for missing checks for
	unrecognized attributes.
	* DbProviderFactories.cs: Marked constants internal. Replaced spaces
	with tabs. Use ConfigurationManager.GetSection instead of deprecated
	ConfigurationSettings.GetConfig.

2007-02-26  Atsushi Enomoto  <atsushi@ximian.com>

	* DbProviderFactoriesConfigurationHandler.cs : there was a config
	  test that used to be broken.

2007-02-26  Atsushi Enomoto  <atsushi@ximian.com>

	* DbProviderFactoriesConfigurationHandler.cs : remove "support"
	  attribute check, as it does not really do anything.

2007-02-19  Atsushi Enomoto  <atsushi@ximian.com>

	* DbProviderFactoriesConfigurationHandler.cs : "support" attribute is
	  optional. Fixed bug #80894.

2007-02-09  Nagappan A  <anagappan@novell.com>

	* DbProviderFactory.cs: Derived class has to implement all the
	methods of this class.

	* DbProviderFactoriesConfigurationHandler.cs (Create): Removed
	bogus MonoTODO

2007-01-08  Nagappan A  <anagappan@novell.com>

	* DataTableMappingCollection.cs (AddRange):  Implemented missing
	NET 2.0 API.

	* DbConnection.cs (GetSchema): Implemented missing NET 2.0 API,
	based on SqlClient implementation.

	* DbConnectionStringBuilder.cs (AppendKeyValuePair): Implemented
	missing API.

	* DbDataReader.cs (GetData): Implemented missing API.
	(GetDbDataReader): Implemented missing API.

	* DbCommandBuilder.cs (BuildCache, BuildInformation)
	(IncludedInInsert, IncludedInUpdate, IncludedInWhereClause)
	(CreateDeleteCommand, CreateInsertCommand, CreateNewCommand)
	(CreateUpdateCommand, CreateParameter): Added private methods.
	(QuotedTableName, GetQuotedString, CatalogLocation)
	(CatalogSeparator, ConflictOption, DataAdapter, QuotePrefix)
	(QuoteSuffix, SchemaSeparator): Implemented public properties.
	(SourceCommand): Implemented private property.
	(Dispose, RowUpdatingHandler): Implemented protected methods.
	(GetDeleteCommand, GetInsertCommand, GetUpdateCommand)
	(QuoteIdentifier, UnquoteIdentifier, RefreshSchema): Implemented
	public methods.

	* DbProviderFactory.cs: Removed MonoTODO's as the derived class
	has to implement all the methods in this class.

	* DataAdapter.cs (Fill): Implemented missing method.

	* DbDataAdapter.cs (FillCommandBehavior): Implemented property.

2006-12-20  Nagappan A  <anagappan@novell.com>

	* DataColumnMapping.cs (GetDataColumnBySchemaAction): Implemented
	2.0 profile method.

	* DbDataReader.cs: Removed TODO's where ever the implementation is
	available.

	* RowUpdatedEventArgs.cs: Removed TODO's where ever the
	implementation is available.

	* DataAdapter.cs (FillInternal): Moved from DbDataAdapater.cs to
	here.
	(BuildSchema): Moved from DbDataAdapter.cs.
	(FillTable): Moved from DbDataAdapter.cs.
	(OnFillErrorInternal): Implemented new internal method to raise an
	event.
	(SetupSchema): Moved from DbDataAdapter.cs.
	(FillInterl): Moved common implementation from DbDataAdapter.cs.
	Removed TODO's where ever the implementation is available.

	* DbDataAdapter.cs (OnRowUpdated): Implemented protected method.
	(OnRowUpdating): Implemented protected method.
	(CreateFillErrorEvent): Moved to DataAdapter.cs.
	(Fill): Moved common implementation to DataAdapter.cs.
	(FillTable): Moved to DataAdapter.cs.
	(BuildSchema): Moved to DataAdapter.cs.
	(SetupSchema): Moved to DataAdapter.cs.

2006-12-11  Miguel de Icaza  <miguel@novell.com>

	* DataAdapter.cs: Removed TODO, NotSupportedException was the
	correct implementation. 

2006-11-28  Nagappan A  <anagappan@novell.com>

	* DbDataAdapter.cs: Removed bogus MonoTODOs

	* DataAdapter.cs: Removed bogus MonoTODOs
	
2006-11-15  Nagappan A  <anagappan@novell.com>

	* DbDataAdapter.cs (FillFromReader): Implemented missing API to
	handle FillErrorEventHandler
	(DataAdapter): Implemented missing .NET 2.0 function
	(GetDeleteCommand): Returns DbDataAdapter deleteCommand internal
	variable.
	(GetInsertCommand): Returns DbDataAdapter insertCommand internal
	variable.
	(GetUpdateCommand): Returns DbDataAdapter updateCommand internal
	variable.

2006-09-06  Konstantin Triger <kostat@mainsoft.com>

	* DbDataAdapter.cs: added basic implementation for some 2.0 features.

2006-08-24  Vladimir Krasnov <vladimirk@mainsoft.com>

	* DbProviderFactories.cs: added TARGET_JVM block to not supported
	functionality

2006-08-06  Konstantin Triger <kostat@mainsoft.com>

	* DbDataReader.cs: DbDataReader.Dipose(bool) - implemented.

2006-07-17  Senganal T <tsenganal@novell.com>

	* Index.cs :
		- GetAllRows : Added. Returns all the rows in the current
		index.
		- GetDistinctRows :Added. Returns all the distinct rows (based
		in Key Columns) in the index.
		
2006-07-13  Senganal T <tsenganal@novell.com>

	* SchemaInfo.cs DbDataAdapter.cs DbConnectionOptions.cs DbParameter.cs 
	DbMetaDataColumnNames.cs DbTransaction.cs DataTableMapping.cs DataAdapter.cs 
	FieldNameLookup.cs DbDataRecord.cs DataColumnMappingCollection.cs DbCommand.cs 
	DbDataPermission.cs DbProviderFactory.cs DbCommandBuilder.cs DbConnectionString.cs 
	RowUpdatedEventArgs.cs DbDataReader.cs DbConnectionStringBuilder.cs DbConnection.cs 
	DataTableMappingCollection.cs :
		2.0 Api fixes

2006-06-15  Senganal T <tsenganal@novell.com>

	* Key.cs : 
		-Equals : Check for Equality of Sort Order too.
		
2006-04-07  Senganal T <tsenganal@novell.com>

	* DbDataAdapter.cs :
		* Update () : If the Update/Delete Query has a null check,
		then populate the parameter value correctly.

2006-03-20  Senganal T <tsenganal@novell.com>

	* DataAdapter.cs :
		- Ctor () : Set Default Values for DataAdapter members
	* DbDataAdapter.cs : 
		- Update () : Call row.AcceptChanges only if AcceptChangesDuringUpdate
		is true. Fixes bug #77776

2006-03-09  Senganal T <tsenganal@novell.com>
	
	* Index.cs :
		- Update () : Add the new record in the correct position

2006-03-07  Senganal T <tsenganal@novell.com>

	* Key.cs : 
		Reverted the changes from the earlier patch.

2006-02-22  Senganal T <tsenganal@novell.com>

	* DbDataAdapter.cs :
		- FillTable : Move BeginLoadData, EndLoadData outside the loop. Also,
		move EndLoadData outsidet try,catch block. FillError is only for errors
		occuring during loading the data into datatable.
	* Key.cs :
		- Set Default value of RowStateFilter to (CurrentRos | OriginalRows).
		- ContainsVersion : If RowStateFilter is set to default value, return true
		for Modified Rows as they can contain Default/Original versions.

2006-02-18  Raja R Harinath  <harinath@gmail.com>

	* DbConnectionStringBuilder.cs (ICollection.CopyTo): Use
	_dictionary, not 'this' in cast.

2006-02-17  Chris Toshok  <toshok@ximian.com>

	* DbDataAdapter.cs: more 2.0 cleanup.

2006-02-17  Chris Toshok  <toshok@ximian.com>

	* DataAdapter.cs, DataColumnMappingCollection.cs,
	DataColumnMapping.cs, DataTableMappingCollection.cs,
	DataTableMapping.cs, DbCommandBuilder.cs,
	DbConnectionStringBuilder.cs, DbParameterCollection.cs,
	DbParameter.cs: pretty major attribute work.
	
2006-02-17  Chris Toshok  <toshok@ximian.com>

	* DbProviderFactory.cs: remove two methods.  and mark the
	DbProviderSupportedClasses ctor as internal since it's not part of
	the public api.

	* DbTable.cs: remove this class from 2.0 build.. leave it for the
	JVM build, I guess?

	* RowUpdatingEventArgs.cs: this class isn't abstract in 2.0.

	* RowUpdatedEventArgs.cs: this class isn't abstract in 2.0.

	* SupportedJoinOperators.cs: new 2.0 enum.

	* CatalogLocation.cs: fix enum values.

	* GroupByBehavior.cs: same.

	* IdentifierCase.cs: same.

	* SchemaTableColumn.cs: class is static, not sealed.  and add
	missing elements.
	
	* SchemaTableOptionalColumn.cs: same.
	
	* DbDataReader.cs: oops, add back in VisibleFieldCount (i missed
	it in the corcompare output), add EditorBrowsable attributes all
	over the place, and fix some method signatures.

	* DbDataUpdatableRecord.cs: remove this 2.0 file.

2006-02-17  Chris Toshok  <toshok@ximian.com>

	* DbDataReader.cs: remove VisibleFieldCount attribute, and remove
	IDataReader2 and IDataRecord2 interfaces.
	
2006-02-13  Senganal T  <tsenganal@novell.com>

	* DbDataAdapter.cs :
		- FillSchema  : 
			- Add table to schema only if MissingSchemaAction is not Ignore
			Add schema to table if MissingSchemaAction is set to either of
			Add or AddWithKey
		- BuildSchema :
			- Set the Schema values only if MissingSchemaAction is set to
			AddWithKey

2006-01-31  Senganal T  <tsenganal@novell.com>

	* DbDataAdapter.cs :
		- Corrected an error in the prev checkin.. Fixes #77415

2006-01-27  Senganal T  <tsenganal@novell.com>

	* DbDataAdapter.cs :
		- Modified schema population to follow MissingSchemaAction and MissingMappingAction
		- Add a column to the Primary Key only if its not a hidden key
		- Added some argument checks
		- Removed some redundant code
	* DataAdapter :
		- Added argument checks
	* ExceptionHelper :
		- Added InvalidEnumException , a helper function to print error msg
		
2006-01-11 Boris Kirzner <borisk@mainsoft.com>
	* Index.cs: removed redundant call to RebuildIndex() in constructor.

2005-12-12  Konstantin Triger <kostat@mainsoft.com>

	* Key.cs: Added ContainsVersion function, refactoring.
	* Index.cs: Fixed Reset() to be ready for Update() calls.
	   Otherwise the index can be rebuilt with new values inside the
	   Update() call itself.
	   Fixed FindIndexExact(), Update(), Delete().

2005-11-22  Konstantin Triger <kostat@mainsoft.com>

	* DbProviderFactory.cs: TARGET_JVM ifdef.

2005-11-21  Senganal T <tsenganal@novell.com>

	* DbDataAdapter.cs
	* DbParameter.cs
	* DbTransaction.cs
	* DbTable.cs
	* DbProviderFactories.cs
	* DbException.cs
	* DbProviderFactory.cs
	* DbCommandBuilder.cs
	* DbDataReader.cs
	* DbParameterCollection.cs
		- Added stubs and other changes for ADO.NET 2.0 compatibility.
	* DbMetaDataCollectionNames.cs (new file)
		- Added DbMetaDataCollectionNames Enumeration 

2005-10-24  Konstantin Triger <kostat@mainsoft.com>

        * DataContainer.cs: removed extra type validation for object container

2005-10-14  Senganal T  <tsenganal@novell.com>

	* DbDataAdapter.cs : 
		- BuildSchema() : Set the value of DataColumn Property 'AllowDBNull'
		as returned by database. Fixes bug#76433. 

2005-09-21 Boris Kirzner <borisk@mainsoft.com>
	* Index.cs: 
		- Rebuild index immediately after construction.
		- Do not add records if they do not padd key filtration.
		- Do not attempt to remove records if the are not in the index.
	* Key.cs:
		- Added HasFilter property, CanContain and DependsOn methods.
		- Equals() uses filter expression comparison.		

2005-09-07 Boris Kirzner <borisk@mainsoft.com>
	* DataContainer.cs: Do not convert value if container type 
	is System.Object.

2005-08-08  Gert Driesen  <drieseng@users.sourceforge.net>

	* DbTypes.cs: Marked internal to fix public API.

2005-08-05  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataAdapter.cs:
	- Update (): set parameter values only after getting the
	appropriate command from command builder. Close reader only if it
	is not closed before. Use parameter's SourceVersion. Whitespace
	corrections to comply with standard.

2005-07-22  Sureshkumar T  <tsureshkumar@novell.com>

	* DataColumnMappingCollection.cs: updated attributes & attribute
	descriptions to match with masterinfos.

2005-07-15  Sureshkumar T  <tsureshkumar@novell.com>

	* DataTableMappingCollection.cs: GetTableMappingBySchemaAction:
	meaningful error message if mapping is missing.

	* DbDataAdapter.cs: Update: meaningful message if table is missing.

2005-06-22  Sureshkumar T  <tsureshkumar@novell.com>

	* Index.cs: Remove : length for Array.Copy (a, i+1, a, i, length -
	(i+1)) corrected.

2005-06-21  Sureshkumar T  <tsureshkumar@novell.com>

	* DbConnectionStringBuilder.cs: Implemented method for parsing
	connection string through "ConnectionString" property.

	* DbConnectionStringBuilderHelper.cs: Helper class to provide
	conversion between string=>.net type mapping for connection string
	builders. The idea is to use between other providers (odbc) as
	well.

2005-05-29 Boris Kirzner <borisk@mainsoft.com>
	* DbCommand.cs - added #ifdef NET_2_0 on DbCommandOptionalFeatures (not used in TARGET_JVM). 
	* ExceptionHelper.cs - removed java references. Exceptions created on formatted text messages. Code styling fixes.
	* DbParameterCollection.cs - implemented indexer properties.
	* DbDataAdapter.cs - delagate exceptions creating to ExceptionHelper.
	
2005-05-25 Konstantin Triger <kostat@mainsoft.com>

      * DataContainer.cs: Correcting the order - first the record is queried whether the value it contains is null, and only if not the value is fetched

2005-05-20 Umadevi S <sumadevi@novell.com>
	* Added file DbProviderSpecificTypePropertyAttribute.cs

2005-05-19 Umadevi S <sumadevi@novell.com>

	* RowUpdatingEventArgs.cs - added BaseCommand property for net 2.0

2005-05-18 Konstantin Triger <kostat@mainsoft.com>

	* DbDataAdapter.cs: Initialize the schema values to defaults if the schema does not contain the information

2005-05-16  Sureshkumar T  <tsureshkumar@novell.com>

	* RecordCache.cs: quick fix to make build 2.0 profile (follow up
	for check in 2005-05-16).

2005-05-16 Konstantin Triger <kostat@mainsoft.com>

	* Index.cs: validation that the updated row belongs to the index

2005-05-02 Konstantin Triger <kostat@mainsoft.com>

	* DataContainer.cs: 
		Added CharDataContainer, SByteDataContainer, UInt16DataContainer, UInt32DataContainer, UInt64DataContainer, DateTimeDataContainer, DecimalDataContainer
		SetItemFromDataRecord: Changed to work with ISafeDataRecord or through GetValue to enable conversion
		return DBNull.Value when the stored value is null
	
	* DbDataAdapter.cs:
		Ensure correct order for LoadDataRow
		Fixing schema creation
		Use NewRowArray API
	
	* DbEnumerator.cs:
		LoadSchema: Retrieve needed fields only
	
	* RecordCache.cs:
		Added Rows-to-Records mapping
		Added ReadIDataRecord method for correct handling of default/auto increment values
	
	* Added Index.cs: Index implementation
	* Added Key.cs: Index descriptor implementation


2005-04-27  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataReader.cs: Added static method to construct the schema
	table with default schema. Could be reused in many places.

2005-04-22  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataAdapter.cs: Moved FillTable and BuildSchema as static
	methods as they are not operating on the current instance. This
	could be reused to fill any table from a data reader.

	* RecordCache.cs: While disposing records, make sure that the
	record is not already disposed. i.e. to make sure later the same
	record is not reused. Implemented a static method to compare two
	version of records in a container.

2005-04-18  Sureshkumar T  <tsureshkumar@novell.com>

	* DataAdapter.cs: Implemenetd OnFillError handler.

	* DbDataAdapter.cs: BuildSchema (): the table to be filled might
	contain few additional columns as well. so mapping length should
	be columns' length + fields' length.

2005-03-24  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataAdapter.cs: Update: If  SourceColumn is null, do not set
	value for the parameter.

2005-05-25 Umadevi S <sumadevi@novell.com>
	* Added DbException.cs

2005-03-23  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataAdapter.cs: For Update, disable ReadOnly constraint
	temporarily before updating the row. Info from Ingo Bauersachs.
	SkipAllRemainingRows should also skip current row (msdn).

2005-03-22  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataAdapter.cs: Update (): update the rows based on the
	UpdateRowSource property. Process further based on the
	RowUpdatedEvent handler argument's Status property.
	Fixes bug #73587. Thanks to mono@rankweg.ch (Ingo Bauersachs) for
	bug report and patch.

	* RowUpdatedEventArgs.cs: if custom error is not set, throw a
	default error.

2005-03-01  Sureshkumar T  <tsureshkumar@novell.com>

	* ConnectionStringsSectionHandler.cs: Added. configuration section
	handler for section "connectionStrings". This handler is a ad hoc
	solution till the new configuration API is available in mono.

2005-02-04  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataAdapter.cs (Update ()) :
	- Check for one return result set and map the values back to
	  datatable.
	- Check for output & return value parameters and update the value
	  back to mapped column
	- check for recordsAffected only after closing the reader.

2005-02-02  Sureshkumar T  <tsureshkumar@novell.com>

	* DbConnection.cs: Implement Dispose pattern.

2005-01-25  Atsushi Enomoto  <atsushi@ximian.com>

	* DbDataPermission.cs : Empty.Union(Empty) is Empty.

2005-01-14  Atsushi Enomoto  <atsushi@ximian.com>

	* DbDataPermissionAttribute.cs, PermissionHelper.cs :
	  fixed some incompatible type of exception between 2.0 and 1.x.
	* DataContainer.cs :
	  Wrap exceptions thrown by SetValue() within ArgumentException.

2004-12-10  Sureshkumar T  <tsureshkumar@novell.com>

	* DbDataAdapter.cs (BuildSchema): Add the primary key schema iff
	MissingSchemaAction is set to AddWithKey. Also, Add auto increment
	value from the source table. fixes bug #67757 and #69110.

2004-11-24  Sureshkumar T  <tsureshkumar@novell.com>

	* DbProviderSupportedClasses.cs: Added correct enum values.
	* DbConnection.cs: Missing virtual method EnlistTransaction Added.
	* DbCommand.cs: Implemented ProviderFactory base factory methods.

2004-11-22  Sureshkumar T  <tsureshkumar@novell.com>

	* DbConnectionStringBuilder.cs: Class for helping creation of db
	connection strings added.

2004-10-01  Sureshkumar T  <tsureshkumar@novell.com>

	* DbProviderFactories.cs: Implemented all the stubs. Added functionality for
	getting available provider factories and creating a specified provider factory.

	* DbProviderFactoriesConfigurationHandler.cs: Added functionality for handling
	DbProviderFactories configuration section.

	* DbProviderFactory.cs: Added protected constructor. SupportedClasses property
	is made abstract.

2004-09-14  Sebastien Pouliot  <sebastien@ximian.com>

	* DbDataPermission.cs: Implemented Intersect, IsSubsetOf and Union.
	Implementation isn't complete as the restrictions seems to change the
	expected results (breaking some rules like x.IsSubsetOf (x) == false).
	Better (real-world) tests cases are required.
	* PermissionHelper.cs: Fixed small differences between System.Data.dll 
	validations wrt to mscorlib.dll (XML and PermissionState).

2004-09-13  Sebastien Pouliot  <sebastien@ximian.com>

	* DbConnectionOptions.cs: New class for Fx 2.0. Partial implementation
	to support new methods in DBDataPermission.
	* DbConnectionString.cs: Updated class to split from/inherit 
	DbConnectionOptions class.
	* DbDataPermission.cs: Implemented Add, Clear, Copy, ToXml methods and
	completed constructors.
	* DbDataPermissionAttribute.cs: Completed/fixed class.
	* PermissionHelper.cs: Helper methods to create permission classes.

2004-08-31 Francisco Figueiredo Jr. <fxjrlists@yahoo.com.br>
	* DbDataAdapter.cs: Fix for out of memory exceptions when trying to fill a dataset with a query which doesn't return a resultset like insert, delete or update.

2004-07-21 Umadevi S <sumadevi@novell.com>
	* DbDataRecord.cs - Fix for bug 58163. Return DBNull instead of null

2004-07-07 Umadevi S <sumadevi@novell.com>
	* DataContainer.cs :CheckedforNull before calling the relavant setmethods in each of the
                SetItemForDataRecord method for the DateTimeClass


2004-06-24  Atsushi Enomoto  <atsushi@ximian.com>

	* DataColumnMappingCollection.cs : fixed typo.
	* DbDataAdapter.cs : column mappings were not filled.

2004-06-24  Atsushi Enomoto  <atsushi@ximian.com>

	* DataTableMapping.cs : Clone() should also clone ColumnMappings.

2004-06-18 Umadevi S <sumadevi@novell.com>
	* DataContainer.cs - CheckedforNull before calling the relavant setmethods in each of the 
		SetItemForDataRecord method for all the classes.

2004-06-17  Boris Kirzner  <borisk@mainsoft.com>
	* RecordCache.cs : Added CopyRecord mathod that copies single record from one table to another.

2004-06-17  Boris Kirzner  <borisk@mainsoft.com>
	* Datacontainer.cs : 
	  - Store and retreival of null and DBNull values reviewed.
	  - Added GetInt64 to support AutoIncrement of DataColumn.
	  - Added missing CopyValue method to BitDataContainer.
	  - Added FillValues method to propagate single value to whole container.
	
2004-06-10 Umadevi S <sumadevi@novell.com>
	* DataTableMappingCollection.cs - fixed nunit testcase errors
	IndexOfDataSetTable method

2004-06-09 Umadevi S <sumadevi@novell.com>
	* DataTableMappingCollection.cs - fixed nunit testcase errors
	- Add, GetByDataSetTable,Insert, Remove, RemoveAt methods.

2004-06-09 Umadevi S <sumadevi@novell.com>
	* DataColumnMappingCollection.cs - fixed nunit testcase errors
	- GetByDataSetColumn,IndexOfDataSetColumn, Remove methods.	

2004-06-08 Umadevi S <sumadevi@novell.com>
	* DataColumnMappingCollection.cs - fixed nunit testcase errors.
	- remove, removeat, contains methods.

2004-06-04  Gert Driesen <drieseng@users.sourceforge.net>

	* DataAdapter.cs: added missing protected ctor
	* DbDataAdapter.cs: added stub for missing protected ctor
	* DbDataPermission.cs: added stubs for missing protected
	ctors, added stub for missing Clear method

2004-06-02  Gert Driesen <drieseng@users.sourceforge.net>
       * DataColumnMappingCollection.cs: added missing attributes on
       indexers

2004-05-27  Boris Kirzner  <borisk@mainsoft.com>
	* DataContainer.cs : Bug fixes in BitDataContainer.get_Item and StringDataContainer.SetValue .

2004-05-20  Gert Driesen (drieseng@users.sourceforge.net)

        *  DbDataPermissionAttribute.cs: change AllowMultiple and
        Inherited to match .NET

2004-05-19  Boris Kirzner  <borisk@mainsoft.com>
	* Datacontainer.cs : CompareValues reviewed. set_Item and get_Item of null and DBNull values in case of DataContainers
	for primitive types reviewed. Added check for null values when reading from IDataRecord.
	
2004-05-19  Boris Kirzner <borisk@mainsoft.com>
	* RecordCache.cs - added. Each instance of record cache belongs to specific table
	and manages pool of records ( indexes into data containers) to be used by data rows.
	* DataContainer.cs - added. Provides implementation for data containers that holds data in arrays 
	of primitives or objects. Each data container belongs to specific DataColumn.
	* DbDataAdapter.cs - changes to complete data storage redesign. Bug fix in FillTable 
	( to fetch exact number of records required ).
	
2004-05-13 Umadevi S (sumadevi@novell.com)
	* DbDataPermissionAttribute.cs - Added KeyRestrictions property with a TODO tag

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* ComparerFactory.cs: marked internal

2003-04-26  Boris Kirzner <borisk@mainsoft.com>
	* DataColumnMappingCollection.cs : Small fix in exception message thrown.
	  
2003-04-25  Boris Kirzner <borisk@mainsoft.com>
	* DbDataAdapter.cs : Fixed bug in Fill :
	  - Reader can have empty results (fo example from UPDATE or DELETE).
	  - Reader can have results with no rows (SELECT that returns 0 rows but have columns)
	  - In FillTable - skip rows only once for each table.
	
2003-04-14  Juraj Skripsky <juraj@hotfeet.ch>
	* DbDataAdapter.cs : Refactoring of Fill. New private method
	FillTable does most of the work now. Use int[] instead of
	hashtable for mapping. Move creation of tableArray[] outside
	of loop.

2004-03-12  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* DbDataPermissionAttribute.cs: Added .Net 1.1 marks
	* DataColumnMapping.cs: DO NOT USE the consts scheme if types can be referenced directly!
	* DataTableMapping.cs: DO NOT USE the consts scheme if types can be referenced directly!
	* DataColumnMappingConverter: Added stub
	* DataTableMappingConverter: Added stub

2004-03-03  Eran Domb  <erand@miansoft.com>
	
	* ComparerFactory.cs : Added.
	
2004-01-10  Atsushi Enomoto  <atsushi@ximian.com>

	* DbDataPermission.cs : tiny fix to pass OleDbPermission.

2004-01-09  Atsushi Enomoto  <atsushi@ximian.com>

	* DbDataPermission.cs : .ctor(PermissionState state) should not call
	  obsolete .ctor(state, allowBlankPassword). csc reports an error.

2003-12-30  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DbDataAdapter.cs: handle MissingShemaAction.AddWithKey, call
	AcceptChanges in Update when a CommandBuilder is used and
	correctly fill information about primary keys in FillSchema.
	Patch from Sergei Malinin (smalinin@amurnet.ru).

2003-12-23  Tim Coleman <tim@timcoleman.com>
	* DbConnectionString.cs:
		Some implementation
	* DbProviderFactory.cs:
		Fix typo to make CLS compliant

2003-12-16  Jackson Harper <jackson@ximian.com>

	* SchemaTableOptionalColumn.cs: Add to fix default build
	
2003-12-16  Tim Coleman <tim@timcoleman.com>
	* CatalogLocation.cs DbCommand.cs DbCommandBuilder.cs
	* DbCommandOptionalFeatures.cs DbCommandSet.cs DbConnection.cs
	* DbConnectionString.cs DbDataSourceEnumerator.cs
	* DbDataUpdatableRecord.cs DbParameter.cs DbParameterCollection.cs
	* DbProviderConfigurationHandler.cs DbProviderFactories.cs
	* DbProviderFactoriesConfigurationHandler.cs DbProviderFactory.cs
	* DbProviderSupportedClasses.cs DbTable.cs DbTransaction.cs
	* GroupByBehavior.cs IdentifierCase.cs SchemaLocation.cs
	* SchemaTableColumn.cs:
		New stubs added for .NET 1.2
	* DataAdapter.cs DataColumnMapping.cs DataColumnMappingCollection.cs
	* DataTableMapping.cs DataTableMappingCollection.cs DbDataAdapter.cs
	* DbDataPermission.cs DbDataPermissionAttribute.cs DbDataRecord.cs
	* FieldNameLookup.cs SchemaInfo.cs:
		Changes made for .NET 1.2

2003-10-22  Eran Domb  <erand@miansoft.com>
	* DbDataAdapter.cs : Check if there is mapping to avoid exception.

2003-11-26  Tim Coleman <tim@timcoleman.com>
	* DbDataReader.cs: Add new stub class

2003-11-23  Pedro Martínez Juliá  <yoros@wanadoo.es>

	* DbDataAdapter.cs: Call command dispose in self dispose method. We
	need to dispose the connections and other stuff stored in the
	commands.

2003-11-10  Pedro Martínez Juliá  <yoros@wanadoo.es>

	* DataColumnMappingCollection.cs: Fix a missing exception when the
	required mapping is not in the collection. MS.NET throws an
	exception there.

2003-10-22  Eran Domb  <erand@miansoft.com>

	* DbDataAdapter.cs (Fill): add only the mapped column to the dataTable (not all columns of dataReader).
            Also closing the dataReader if an exception is thrown.
	(Fill): the same as above.
	(SetupSchema): in now return string (the table name). 
	(GetFillParameters): fix a bug.
	(BuildSchema) - it now return Hashtable. Add columns to the table only if there is a mapping. Build an Hashtable that maps the columns from the table to the column from the reader.
	(Update): first open the connection if needed. Catch an exception of the ExecuteQuery.
	

2003-09-30  Duncan Mak  <duncan@ximian.com>

	Patch from Eran Domb <eran@mainsoft.com>.
	
	* DbDataAdapter.cs (Fill): Fixed an Exception from being thrown.

2003-09-25  Duncan Mak  <duncan@ximian.com>

	* DbDataAdapter.cs (Fill): Patch from Eran Domb, <eran@mainsoft.com>.
	Fixes a possible NullReferenceException, more details here:

	http://lists.ximian.com/archives/public/mono-devel-list/2003-September/002116.html

2003-09-21  eran <erand@mainsoft.com>

	* DbDataRecord.cs: The method
	System.Data.Common.DbDataRecord.GetValues(object[] values) did not
	put the values of the DbDataRecord into values parameter.

2003-08-26  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DbDataAdapter.cs: provide a Type for ToArray to avoid invalid cast
	exception. Thanks to Mark Easton <measton@tebiki.co.uk>.

2003-07-31  Duncan Mak  <duncan@ximian.com>

	* DataAdapter.cs (CloneInternals): Mark with ObsoleteAttribute for
	NET_1_1.

2003-03-21  Alan Tam <Tam@SiuLung.com>

	* DbDataAdapter.cs: Update now uses correct DataRowVersion
	when accessing the data.

2003-03-17  Aleksey Demakov <avd@openlinksw.com>

	* DbDataAdapter.cs: BuildSchema now uses ColumnName instead
	of BaseColumnName (bug #39830) for DataColumn names.
	BaseTableName is no longer taken into account as well.

2003-02-28  Aleksey Demakov <avd@openlinksw.com>

	* DbDataAdapter.cs: Update (DataSet) updates the default
	table only.

2003-02-25  Alan Tam <Tam@SiuLung.com>
	
	* DbDataAdapter.cs: Added support for filling when schema is present.
	Fixed incorrect behavior when ColumnMapping is present
	when more than one fields have the same name. Implemented Dispose.
	Fixed error when there is no ColumnMapping at all.
	Still have some problems in finding the correct TableMapping
	because the SourceTable name is not present in BuildSchema

2003-02-24  Aleksey Demakov <avd@openlinksw.com>

	* DbDataAdapter.cs: The original code might pass a null DataTableMapping
	value which is then used to create a RowUpdatingEventArgs
	instance. So RowUpdatingEvent handler (for instance
	CommandBuilder) could get null DataTableMapping which
	might be unexpected. The patch makes sure that a non-null
	DataTableMapping is passed.

2003-01-26  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DbEnumerator.cs: why does the runtime throw an invalid cast here? The
	object is an Int16... Gotta fill a bug report and when fixed undo this
	patch.

2003-01-08  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DbDataRecord.cs: return DbNull.Value in GetValue () if value is null.

2002-10-31  Daniel Morgan <danmorg@sc.rr.com>

	* SchemaInfo.cs: added missing properties to fix mcs build

2002-05-05  Miguel de Icaza  <miguel@ximian.com>

	* DataTableMapping.cs, DataTableMappingCollection.cs: comment out
	interfaces we do not implement yet.

	* DbDataAdapter.cs: Stub IEnumerable, comment out interfaces
	we do not implement yet.

	* DbDataPermissionAttribute.cs: call base constructor.

